<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import AdminProductModule from "~/store/adminCollection";
import { api } from "~/common/constaint";
import _ from "lodash";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({})
export default class adminUpsaleComponent extends Vue {
  adminProduct = getModule(AdminProductModule, this.$store);
  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;

  configProduct = {
    page: 1,
    limit: 10,
    search: "",
    filter: {},
  };
  totalPageProduct: number = 0;

  listProduct = [];
  listAllProduct = [];
  listCollection: any = [];
  listProductIds = [];

  productId = "";
  loadingTable = false;
  loadingTableProduct = false;

  statusRecently = false;
  filterCollection = "All";
  dialogAddProduct = false;
  dialogDeleteProduct = false;
  loading = false;

  mounted() {
    this.onGetListCollection();
    this.onGetListProduct();
    this.onGetListAllProduct();
    this.onGetStatusRecently();
  }

  async onGetStatusRecently() {
    try {
      const response = await this.$api.recently.get();
      if (response.data) {
        this.statusRecently = response.data.status;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListCollection() {
    try {
      const response = await this.$store.dispatch(
        "adminCollection/onGetListCollection",
        {
          ctx: this,
        }
      );
      if (response?.data?.data) {
        this.listCollection = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListAllProduct() {
    try {
      this.loadingTable = true;
      const response = await this.$api.bestSeller.list();
      if (response?.data) {
        this.listAllProduct = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListProduct() {
    try {
      if (this.filterCollection !== "All") {
        //@ts-ignore
        this.configProduct.filter["collectionId"] = this.filterCollection;
      } else {
        //@ts-ignore
        delete this.configProduct.filter["collectionId"];
      }
      this.loadingTableProduct = true;
      const response = await this.$api.product.getListAdmin(this.configProduct);

      if (response?.data?.data) {
        const { page, total, totalInList, data } = response.data;
        this.totalPageProduct = Math.ceil(total / this.configProduct.limit);
        this.listProduct = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableProduct = false;
    }
  }

  async onAddProduct() {
    try {
      this.loading = true;
      await this.$api.bestSeller.addBestSeller(this.listProductIds);
      this.$pushNotification.success("Add product to success list");
      this.dialogAddProduct = false;
      this.listProductIds = [];
      this.onGetListAllProduct();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onChangedStatus(status: number, productId: string) {
    try {
      if (!productId)
        return this.$pushNotification.error("Not found productId");
      await this.$api.bestSeller.changePosition(status, productId);
      this.$pushNotification.success("Change position succesfully");
      this.onGetListAllProduct();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onChangeStatusRecently() {
    try {
      this.loading = true;
      await this.$api.recently.edit(this.statusRecently);
      this.$pushNotification.success("Change status succesfully");
      this.onGetStatusRecently();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  openDialogDeleteProduct(productId: string) {
    if (productId) {
      this.productId = productId;
      this.dialogDeleteProduct = true;
    }
  }
  async onDeleteProduct() {
    try {
      this.loading = true;
      await this.$api.bestSeller.delete(this.productId);
      this.$pushNotification.success("Remove product from list successfully");
      this.dialogDeleteProduct = false;
      this.onGetListAllProduct();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  convertImg(product: any) {
    if (product?.coverId?.imageUrl) {
      return `${api}/${product.coverId.imageUrl}`;
    }
    return "";
  }

  convertImage(product: any) {
    if (product?.productId?.listImageId?.length) {
      return `${api}/${product.productId.listImageId[0].imageUrl}`;
    }
    return "";
  }

  totalStockProduct(product: any) {
    let num = 0;
    if (product && product.productId) {
      for (let sanpham of product.productId.variant) {
        if (sanpham && sanpham.stock) {
          num += sanpham.stock;
        }
      }
    }
    return num || product.stock;
  }

  calcPrice(product: any) {
    let price = 0;
    if (product && product.listVariant && product.listVariant.length) {
      price = product.listVariant[0].price;
    } else {
      return product.productId?.listVariant[0]?.price || 0;
    }
    return price;
  }

  formatDate(date: string) {
    return moment(date).format("HH:mm DD/MM/YYYY");
  }

  get findNameProduct() {
    const findProduct: any = this.listProduct.find(
      (product: any) => product._id === this.productId
    );
    if (findProduct) {
      return findProduct.name;
    }
    return "";
  }

  @Watch("dialogAddProduct")
  changedDialogAddRelatedProduct(val: Boolean) {
    if (val) {
      this.onGetListProduct();
      // this.listCollection.unshift({ name: "All", value: "" });
    } else {
      // this.listCollection.shift();
    }
  }

  @Watch("dialogAddProduct")
  changedStatus(value: boolean) {
    if (value) {
      this.onGetListAllProduct();
    }
  }

  @Watch("configProduct.search")
  changedSearchProduct(val: string) {
    if (!val) {
      this.onGetListProduct();
    }
  }
  @Watch("configProduct.page")
  changedPageProduct(val: string) {
    this.onGetListProduct();
  }

  @Watch("filterCollection")
  changedFilterCollection() {
    this.onGetListProduct();
  }
}
</script>

<style></style>
